#!/bin/sh -x
#
# NARR version makes G2 to g1 and plumes
#  Lag is set to 3hours
#  Set path based on machines
#  currently the pl file is only echoed 
#
EFS=SREF
#
rawdir=/scratch/local/data/fxa/Grid/SBN/rawGrib2
ldadir=/data/ldad/alps_ingest
workDir=/data/local/localapps/alps_ingest
export workDir=$workDir
echo workDir $workDir
cd $workDir
#
# 2. check inputs
#
if [ $1X == X ]; then
  LAG=1
else
  LAG=$1
fi
echo LAG WILL BE $LAG
result=`${workDir}/getTime.pl $LAG $EFS`
DTG=`echo $result| cut -d, -f4`
echo dtg $DTG
#
# 3. Grab GRIB2 SREF files and place into rawGrib2 directory
#    (Updated to run getGRIB2.pl outside of the AWIPS firewall. -Matt Sardi, OKX)
#
/usr/local/bin/ssh ldad@ls1 "${ldadir}/getGRIB2.pl $EFS $DTG$"
/usr/local/bin/scp ldad@ls1:${ldadir}/SREF/rawGrib2/* $rawdir
/usr/local/bin/ssh ldad@ls1 "rm ${ldadir}/SREF/rawGrib2/*"
#
# 4. Convert the NCEP file names to ALPS decodables.
#
$workDir/SREFtoALPS.csh
#
exit
