#!/usr/bin/perl
#
#  Get FULLDTG of model run
#  -All models will be based on 6-hour cycles (00,06...18)
#  -SREF will be based on CYCLE-3
#
#  Program has time error on 31 August from 1 Sept ???
#
my($LAG,$MODEL,$TEST)=@ARGV;
if($#ARGV < 0){
    print "No inputs need LAG and a model would be good.\n ./getTime.pl 2 SREF\n";
    exit;
   }
#
#  Get Time data
#
$OFFSET=0;
#print "Inputs $LAG for MODEL $MODEL\n";
if($MODEL eq "SREF" | $MODEL eq sref | $MODEL eq SREF21 | $MODEL eq sref21) {$OFFSET=3; 
                      if($TEST  eq "true"){print "OFFSET SET TO $OFFSET\n";}
                      }
#print "Use this OFFSET $OFFSET\n";
($DTG,$CYCLE,$HOUR)=getTime($LAG,$OFFSET,$TEST);
print "$MODEL,$DTG,$CYCLE,$HOUR\n";
#
sub getTime{
#
#  Get DTG and current cycle based on a Lag time
#    -LAG is typically used for model data as it takes time to process.
#    -OFFSET: CYCLES are based on 6-hour data but SREF is offset by -3 hours
#     this allows say 12Z to be 09Z and 18Z to be 15Z for SREF data.
#     Normally, the offset is 0 hours
#
#  getTime in format YYYYMMDD for directories
#  get cycle in form HH
# Get GMT Time DATA FOR PATH SETTING
#  RETURN YYYYMMDD to make local and NCEP data PATH NAMES COMPLETE
# Month is 0-11
# Year is years from 1900
#
my($LAG,$OFFSET,$TEST)=@_;
use Time::Local;
$DTG     = time;
$LDTG    = $DTG - $LAG*60*60;
#
#   Get parts of time ---current and lagged time
#
($sec,$min,$hour,$mday,$month,$year,$wday,$yday,$isds) = gmtime($DTG);
($lsec,$lmin,$lhour,$lmday,$lmonth,$lyear,$lwday,$lyday,$lisds) = gmtime($LDTG);
#  
#  Get monthname
#
$monthName=(qw(Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec))[(gmtime)[4]];
#
#   Fix year and month data and set YYYYYMMDD structures for current and Lag
#
$year   = $year +1900;
$month  = $month;
$lyear  = $lyear +1900;
$lmonth = $lmonth;
$CYCLE=CYCLE($lhour);
$DTG=$year.&pad($month+1).&pad($mday).&pad($hour);
$LDTG=$lyear.&pad($lmonth+1).&pad($lmday).&pad($CYCLE);
#
#  off set time based on cycle of lag time
#
$OffTime=timegm(0,0,$CYCLE,$lmday,$lmonth,$lyear);
($osec,$omin,$ohour,$omday,$omonth,$oyear,$owday,$oyday,$oisds) = gmtime($OffTime);
$ODTG=$lyear.&pad($omonth+1).&pad($omday).&pad($ohour);
#print "LAG: $LDTG OFFSET: $ODTG and lag day is $lmday OFFSET value: $OFFSET\n";
$OFFDTG  = $OffTime - $OFFSET*60*60;
($offsec,$offmin,$offhour,$offmday,$offmonth,$offyear,$offwday,$offyday,$offisds) = gmtime($OFFDTG);
#print "OFFSET: $offyear $offmonth $offmday\n";
$OFFDTG=($offyear+1900).&pad($offmonth+1).&pad($offmday).&pad($offhour);
if($TEST eq "true" ){print "TIME :LAG: $LAG DTG: $DTG LAGDTG: $LDTG OFFSET: $OFFDTG\n";}
#
return $DTG,$LDTG,$OFFDTG;}
#
#
sub CYCLE{
#
# From Base hour compute the cycle we will assume 6 hour data increments here
#
my($hour)=@_;
$CYCLE = int $hour/6;
$CYCLE = 6*$CYCLE;
return $CYCLE;}

#
sub pad{
#
# Pad a number so 9 in 09 and 1 is 01 etc
#  Take input as an array (@_) and only use first value;
#
   my($in)=@_;
   if($in < 10){$in="0".$in;}
   return $in;}
#####
